library flutter_xxtext;

import 'package:flutter/material.dart';


typedef ShadeBuilder = Widget Function(
    BuildContext context, String text, Color);

class FlutterPackage extends StatelessWidget {
  final String text;
  final Color textColor;
  final Color shadeColor;
  final double xTans;
  final double yTans;
  final ShadeBuilder shadeBuilder;

  FlutterPackage({this.text,
    this.textColor,
    this.shadeColor,
    this.xTans,
    this.yTans,
    this.shadeBuilder}) : assert(text != null),
        assert(textColor != null),
        assert(shadeColor != null),
        assert(shadeBuilder != null);

  @override
  Widget build(BuildContext context) {
    // TODO: implement build
    return Stack(
      children: <Widget>[
        shadeBuilder(context, text, textColor),
        Transform(
          transform:
          Matrix4.translationValues(xTans ?? 10.0, yTans ?? 20.0, 0.0),
          child: shadeBuilder(context, text, shadeColor),
        ),
        Transform(
          transform:
          Matrix4.translationValues(xTans ?? 30.0, yTans ?? 60.0, 0.0),
          child: shadeBuilder(context, text, shadeColor),
        ),
      ],
    );
  }
}
